POJ1195 Mobile phones 【二维树状数组】
Time Limit: 5000MS | Memory Limit: 65536K | |
Total Submissions: 14288 | Accepted: 6642 |
Description
number of active mobile phones inside a square can change because a phone is moved from a square to another or a phone is switched on or off. At times, each base station reports the change in the number of active phones to the main base station along with
the row and the column of the matrix.
Write a program, which receives these reports and answers queries about the current total number of active mobile phones in any rectangle-shaped area.
Input
integers according to the following table.
The values will always be in range, so there is no need to check them. In particular, if A is negative, it can be assumed that it will not reduce the square value below zero. The indexing starts at 0, e.g. for a table of size 4 * 4, we have 0 <= X <= 3 and
0 <= Y <= 3.
Table size: 1 * 1 <= S * S <= 1024 * 1024
Cell value V at any time: 0 <= V <= 32767
Update amount: -32768 <= A <= 32767
No of instructions in input: 3 <= U <= 60002
Maximum number of phones in the whole table: M= 2^30
Output
Sample Input
0 4
1 1 2 3
2 0 0 2 2
1 1 1 2
1 1 2 -1
2 1 1 2 3
3
Sample Output
3
4
【问题描写叙述】
如果第四代移动电话的收发站是这样执行。整个区域被切割成非常小的方格。全部的方格组成了一个S*S的矩阵,行和列从0~S-1编号。每一个小方格都包括一个收发站。每一个方格内的手机的移动电话数量能够不断改变,由于手机用户在各个方格之间移动,也实用户开机或者关机。一旦某个方格里面开机的移动电话数量发生了变化,该方格里的收发站就会向总部发送一条信息说明这个改变量。
总部要你写一个程序,用来管理从各个收发站收到的信息。老板可能随时会问:某个给定矩形区域内有多少部开机的移动电话啊?你的程序必需要能随时回答老板的问题。
【输入输出数据】
从标准输入读入整数,向标准输出写入你对老板的回答。
输入数据的格式例如以下:每一个输入独立成一行。一个输入包含一个指示数和一些參数,见下表:
指示数 |
參数 |
意义 |
0 |
S |
初始指令。整个区域由S*S个小方格组成。这个指令仅仅会在一開始出现一次。 |
1 |
X Y A |
方格(X,Y)内的开机移动电话量添加了A。A可能是正数也可能是负数 |
2 |
L B R T |
询问在矩形区域(L,B)—(R,T)内有多少部开机的移动电话。矩形区域(L,B)—(R,T)包含全部的格子(X。Y)满足L<=X<=R,B<=Y<=T. |
3 |
终止程序。 这个指令仅仅会在最后出现一次。 |
全部的数据总是在给定范围内,你不须要差错。
特别的,假设A是负数,你能够觉得该操作不会让该格子的开机移动电话数变成负数。格子是从0開始编号的,比方一个4*4的区域,全部的格子(X,Y)应该表示为:0<=X<=3,0<=Y<=3。
对于除了2之外的指示,你的程序不应该输出不论什么东西。
假设指示是2。那么你的程序应该向标准输出写入一个整数。
【数据限制】
区域大小 |
S * S |
1 * 1 <= S * S <= 1024 * 1024 |
每一个格子的值 |
V |
0 <= V <= 32767 |
添加/降低量 |
A |
-32768 <= A <= 32767 |
指令总数 |
U |
3 <= U <= 60002 |
全部格子的和 |
M |
M= 2^30 |
第一次在OJ题中用函数指针数组。感觉挺简洁的。
#include <stdio.h> int tree[1030][1030], size; int lowBit(int n)
{
return n & (-n);
} void getSize()
{
scanf("%d", &size);
} void update()
{
int x, y, val;
scanf("%d%d%d", &x, &y, &val);
++x; ++y; int temp;
while(x <= size){
temp = y;
while(temp <= size){
tree[x][temp] += val;
temp += lowBit(temp);
}
x += lowBit(x);
}
} int getSum(int x, int y)
{
int sum = 0, temp;
while(x > 0){
temp = y;
while(temp > 0){
sum += tree[x][temp];
temp -= lowBit(temp);
}
x -= lowBit(x);
}
return sum;
} void query()
{
int x1, y1, x2, y2;
scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
++x1; ++y1; ++x2; ++y2; int sum = getSum(x2, y2) - getSum(x2, y1 - 1) -
getSum(x1 - 1, y2) + getSum(x1 - 1, y1 - 1);
printf("%d\n", sum);
} void (*funArr[])() = {
getSize, update, query
}; //函数指针数组 int main()
{
int com;
while(scanf("%d", &com), com != 3)
(*funArr[com])();
return 0;
}
POJ1195 Mobile phones 【二维树状数组】的更多相关文章
- 【poj1195】Mobile phones(二维树状数组)
题目链接:http://poj.org/problem?id=1195 [题意] 给出一个全0的矩阵,然后一些操作 0 S:初始化矩阵,维数是S*S,值全为0,这个操作只有最开始出现一次 1 X Y ...
- POJ 1195:Mobile phones 二维树状数组
Mobile phones Time Limit: 5000MS Memory Limit: 65536K Total Submissions: 16893 Accepted: 7789 De ...
- poj 1195 Mobile phones(二维树状数组)
树状数组支持两种操作: Add(x, d)操作: 让a[x]增加d. Query(L,R): 计算 a[L]+a[L+1]……a[R]. 当要频繁的对数组元素进行修改,同时又要频繁的查询数组内任一 ...
- 【POJ1195】【二维树状数组】Mobile phones
Description Suppose that the fourth generation mobile phone base stations in the Tampere area operat ...
- Mobile phones_二维树状数组
[题意]给你一个矩阵(初始化为0)和一些操作,1 x y a表示在arr[x][y]加上a,2 l b r t 表示求左上角为(l,b),右下角为(r,t)的矩阵的和. [思路]帮助更好理解树状数组. ...
- poj1195Mobile phones(二维树状数组)
http://poj.org/problem?id=1195 模版题 i写成k了 找了一个多小时没找出来.. #include <iostream> #include<cstring ...
- poj_1195Mobile phones,二维树状数组
#include<iostream> #include<cstdio> #include<cstring> #include<algorithm> us ...
- poj 1195:Mobile phones(二维树状数组,矩阵求和)
Mobile phones Time Limit: 5000MS Memory Limit: 65536K Total Submissions: 14489 Accepted: 6735 De ...
- (简单) POJ 1195 Mobile phones,二维树状数组。
Description Suppose that the fourth generation mobile phone base stations in the Tampere area operat ...
- POJ 1195 Mobile phones (二维树状数组)
Description Suppose that the fourth generation mobile phone base stations in the Tampere area operat ...
随机推荐
- VMware Workstation 14 UEFI启动
1.新建虚拟机 完成后不要启动 修改虚拟机目录下的XXX.vmx文件 添加一行:firmware="efi" 然后启动UEFI安装系统.
- Android Studio修改默认字体大小
安装Android Studio后,默认的字体很小,看着很不舒服,如下图 因此,我们需要改变字体大小,步骤如下: 一.打开设置 二.找到Font,这里系统的主题不能修改,我们点击Save As... ...
- 开门人和关门人(结构体+sort)
每天第一个到机房的人要把门打开,最后一个离开的人要把门关好.现有一堆杂乱的机房签 到.签离记录,请根据记录找出当天开门和关门的人. Input 测试输入的第一行给出记录的总天数N ( > ...
- cxLookupCombobox的多字段模糊匹配
查了网上很多资料,懒人输入:通过程序使用过滤对话达到自己的目的: 用到cxFilter单元: cbb_DoctorOrder.Properties.View.DataController.Filter ...
- selenium grid使用(windows+centos7.4)
windows作为hub,centos7.4作为node. firefox用的centos7自带的52版本,懒得更新. vm虚拟机必须设置成bridge模式上网,否则报错.具体参见博文:Vmware改 ...
- HackerRank# The Coin Change Problem
原题地址 背包问题,没啥好说的,记得用long long,否则会爆 代码: #include <cmath> #include <cstdio> #include <ve ...
- 【状压DP】OpenJ_POJ - C17K Lying Island
https://vjudge.net/contest/171652#problem/K [题意] 小岛上有n个人,有些是好人(一定是真话),有些是坏人(可能是真话也可能是假话),现在要判断最多有多少好 ...
- 博弈 Nim问题 POJ2234
定义: 通常的Nim游戏的定义是这样的:有若干堆石子,每堆石子的数量都是有限的,合法的移动是 “选择一堆石子并拿走若干颗(不能不拿)”,如果轮到某个人时所有的石子堆都已经被拿空了, 则判负(因为他此刻 ...
- The Grove(poj 3182)
题意:一个n*m(n,m<=50)的矩阵有一片连着的树林,Bessie要从起始位置出发绕林子一圈再回来,每次只能向横着.竖着或斜着走一步.问最少需多少步才能完成. /* 如果我们用搜索来写的话, ...
- HDU 2352 Verdis Quo
罗马数字转化为十进制的值 题目非常的长 提取有效信息 并且介绍很多规则 但是事实上有用的信息就是如何加 什么时候减 当当前字母小于下一个字母时 减去当前字母的值 #include <iostre ...